#!/usr/bin/env python

import sys, os, subprocess as sp
import commands as cmmd
import math

if len(sys.argv ) < 2:
    print "{0}: <dataset-name>".format(sys.argv[0])
    exit(-1)

converter = "convert2binary"
origdir   = "orig"
datadir   = "cbin"

dataset = sys.argv[1]

print "Dataset:", dataset

num_splits = [2, 4, 8, 16, 32, 64, 128]
candidates = []
to_remove = []

test_file_name = origdir + "/" + dataset + ".test"
out_file_name  = datadir + '/' + dataset + ".test"
if not os.path.exists(test_file_name):
    print "File does not exists:", test_file_name
    exit(-2)

candidates.append([test_file_name, out_file_name+".cbin"])

train_file_name = origdir + '/' + dataset + ".train"
out_file_name   = datadir + '/' + dataset + ".train"
if not os.path.exists(train_file_name):
    print "File does not exists:", train_file_name
    exit(-2)

candidates.append([train_file_name, out_file_name+".cbin"])

ln = float(cmmd.getoutput("awk 'END{printf NR}' " + train_file_name))
for n in num_splits:
    cmd = "split --verbose -d -a " + str(int(math.floor(math.log(n,10))+1))
    cmd += " -l " + str(int(math.ceil(ln/n))) + " "
    cmd += train_file_name + " " + out_file_name + "." + str(n) + "."
    #cmd += " --additional-suffix=.of." + str(n)
    cmd += " | cut -d' ' -f 3"
    print cmd
    output = cmmd.getoutput(cmd)
    for line in output.split('\n'):
						# dont know why inverted start/end quote have 3 bytes"
        split_file = line[3:-3].encode('ascii', 'ignore')
        print split_file
        candidates.append([split_file, split_file+".cbin"])
    #    to_remove.append(split_file)

for candi, cbin in candidates:
    print candi, cbin
    if not os.path.exists(cbin):
        cmd = converter + " " + candi + " " + cbin
        print cmd
        #sp.call(cmd, shell=True)

#for candi, cbin in candidates:
#    print candi, cbin
#    if not os.path.exists(cbin):
#        cmd = converter + " " + candi + " " + cbin
#        print cmd
#        sp.call(cmd, shell=True)
#
#for tmp in to_remove:
#    sp.call("rm " + tmp, shell=True)
