#ifndef __LOSS_FUNCTION_HPP__
#define __LOSS_FUNCTION_HPP__

#include "../dataparser/structures.hpp"
#include "../params.hpp"

template<typename L, typename D>
class LossFunction {
public:
	LossFunction(ProblemData<L,D>& pd, Parameters &par) : instance(pd), params(par) {}

	virtual ~LossFunction() {}

	virtual void resetInstance() = 0;
	virtual void computeObjectiveValue(std::vector<D> & w, double &finalDualError, double &finalPrimalError) = 0;
	virtual void computePrimalObjective(ProblemData<L,D> &generic_instance, std::vector<D> & w, D &localHingeLoss) = 0;
	virtual void computeDualObjective(D &localError) = 0;

protected:
  ProblemData<L,D>& instance;
  Parameters& params;

};

#endif // __LOSS_FUNCTION_HPP__
